<html>
<head>
<title>OgreCompositorManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCompositorManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCompositorManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __CompositorManager_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __CompositorManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreResourceManager_8h.html">OgreResourceManager.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCompositor_8h.html">OgreCompositor.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRectangle2D_8h.html">OgreRectangle2D.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystem_8h.html">OgreRenderSystem.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreCompositionTechnique_8h.html">OgreCompositionTechnique.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00058"></a><a class="code" href="classOgre_1_1CompositorManager.html">00058</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre.">CompositorManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;CompositorManager&gt;
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060     <span class="keyword">public</span>:
<a name="l00061"></a>00061         <a class="code" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre.">CompositorManager</a>();
<a name="l00062"></a>00062         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre.">CompositorManager</a>();
<a name="l00063"></a>00063 
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* createImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00066"></a>00066             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader,
<a name="l00067"></a>00067             <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params);
<a name="l00068"></a>00068 
<a name="l00071"></a>00071         <span class="keywordtype">void</span> initialise(<span class="keywordtype">void</span>);
<a name="l00072"></a>00072 
<a name="l00075"></a>00075         <span class="keywordtype">void</span> parseScript(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName);
<a name="l00076"></a>00076 
<a name="l00082"></a>00082         <a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a> *getCompositorChain(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp);
<a name="l00083"></a>00083 
<a name="l00086"></a>00086         <span class="keywordtype">bool</span> hasCompositorChain(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00090"></a>00090         <span class="keywordtype">void</span> removeCompositorChain(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp);
<a name="l00091"></a>00091 
<a name="l00099"></a>00099         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> *addCompositor(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;compositor, <span class="keywordtype">int</span> addPosition=-1);
<a name="l00100"></a>00100 
<a name="l00103"></a>00103         <span class="keywordtype">void</span> removeCompositor(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;compositor);
<a name="l00104"></a>00104 
<a name="l00110"></a>00110         <span class="keywordtype">void</span> setCompositorEnabled(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;compositor, <span class="keywordtype">bool</span> value);
<a name="l00111"></a>00111 
<a name="l00114"></a>00114         <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> *_getTexturedRectangle2D();
<a name="l00115"></a>00115 
<a name="l00117"></a>00117         <span class="keywordtype">void</span> removeAll(<span class="keywordtype">void</span>);
<a name="l00118"></a>00118 
<a name="l00120"></a>00120         <span class="keywordtype">void</span> _reconstructAllCompositorResources();
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classOgre_1_1CompositorManager.html#a93c776ce5090cfe5a43e0b7061d00490">00122</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html#a7ac5eb4c7cfd2a56392fe863bcb415c0">set&lt;Texture*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#a93c776ce5090cfe5a43e0b7061d00490">UniqueTextureSet</a>;
<a name="l00123"></a>00123 
<a name="l00131"></a>00131         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> getPooledTexture(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; localName, 
<a name="l00132"></a>00132             <span class="keywordtype">size_t</span> w, <span class="keywordtype">size_t</span> h, 
<a name="l00133"></a>00133             <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> f, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> aa, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; aaHint, <span class="keywordtype">bool</span> srgb, <a class="code" href="classOgre_1_1CompositorManager.html#a93c776ce5090cfe5a43e0b7061d00490">UniqueTextureSet</a>&amp; texturesAlreadyAssigned, 
<a name="l00134"></a>00134             <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* inst, <a class="code" href="classOgre_1_1CompositionTechnique.html#a72f5c327008d8292c004bcd5bdf6fb1e">CompositionTechnique::TextureScope</a> scope);
<a name="l00135"></a>00135 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> freePooledTextures(<span class="keywordtype">bool</span> onlyIfUnreferenced = <span class="keyword">true</span>);
<a name="l00140"></a>00140 
<a name="l00144"></a>00144         <span class="keywordtype">void</span> registerCompositorLogic(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1CompositorLogic.html" title="Interface for compositor logics, which can be automatically binded to compositors, allowing per-compositor logic (such as attaching a relevant listener) to happen automatically.">CompositorLogic</a>* logic);
<a name="l00145"></a>00145 
<a name="l00148"></a>00148         <span class="keywordtype">void</span> unregisterCompositorLogic(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00149"></a>00149         
<a name="l00152"></a>00152         <a class="code" href="classOgre_1_1CompositorLogic.html" title="Interface for compositor logics, which can be automatically binded to compositors, allowing per-compositor logic (such as attaching a relevant listener) to happen automatically.">CompositorLogic</a>* getCompositorLogic(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00153"></a>00153 
<a name="l00156"></a>00156         <span class="keywordtype">void</span> registerCustomCompositionPass(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1CustomCompositionPass.html" title="Interface for custom composition passes, allowing custom operations (in addition to the quad...">CustomCompositionPass</a>* customPass);
<a name="l00157"></a>00157         
<a name="l00160"></a>00160         <a class="code" href="classOgre_1_1CustomCompositionPass.html" title="Interface for custom composition passes, allowing custom operations (in addition to the quad...">CustomCompositionPass</a>* getCustomCompositionPass(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00161"></a>00161 
<a name="l00177"></a>00177         <span class="keyword">static</span> <a class="code" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre.">CompositorManager</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00193"></a>00193         <span class="keyword">static</span> <a class="code" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre.">CompositorManager</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195     
<a name="l00196"></a>00196     <span class="keyword">private</span>:
<a name="l00197"></a><a class="code" href="classOgre_1_1CompositorManager.html#a2915329ff196fde1386b9bccbbfe4bf9">00197</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;Viewport*, CompositorChain*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#a2915329ff196fde1386b9bccbbfe4bf9">Chains</a>;
<a name="l00198"></a><a class="code" href="classOgre_1_1CompositorManager.html#a07b50c5d9e029a4dba434482af098ec6">00198</a>         <a class="code" href="classOgre_1_1CompositorManager.html#a2915329ff196fde1386b9bccbbfe4bf9">Chains</a> <a class="code" href="classOgre_1_1CompositorManager.html#a07b50c5d9e029a4dba434482af098ec6">mChains</a>;
<a name="l00199"></a>00199 
<a name="l00202"></a>00202         <span class="keywordtype">void</span> freeChains();
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classOgre_1_1CompositorManager.html#a8fabe8f9ef88b1c52d770ee48d7399dd">00204</a>         <a class="code" href="classOgre_1_1Rectangle2D.html" title="Allows the rendering of a simple 2D rectangle This class renders a simple 2D rectangle; this rectangl...">Rectangle2D</a> *<a class="code" href="classOgre_1_1CompositorManager.html#a8fabe8f9ef88b1c52d770ee48d7399dd">mRectangle</a>;
<a name="l00205"></a>00205 
<a name="l00207"></a><a class="code" href="classOgre_1_1CompositorManager.html#a538be80b105f72d205af2e7d43fea837">00207</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CompositorInstance *&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#a538be80b105f72d205af2e7d43fea837" title="List of instances.">Instances</a>;
<a name="l00208"></a><a class="code" href="classOgre_1_1CompositorManager.html#a55fca3bcfc893c00cef6d5b92f36e840">00208</a>         <a class="code" href="classOgre_1_1CompositorManager.html#a538be80b105f72d205af2e7d43fea837" title="List of instances.">Instances</a> <a class="code" href="classOgre_1_1CompositorManager.html#a55fca3bcfc893c00cef6d5b92f36e840">mInstances</a>;
<a name="l00209"></a>00209 
<a name="l00211"></a><a class="code" href="classOgre_1_1CompositorManager.html#a0f0f6dee9b0bbd03f85b9bdaf768dd40">00211</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, CompositorLogic*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#a0f0f6dee9b0bbd03f85b9bdaf768dd40" title="Map of registered compositor logics.">CompositorLogicMap</a>;
<a name="l00212"></a><a class="code" href="classOgre_1_1CompositorManager.html#ac4c61ca88567ecb84701e6b460fcb375">00212</a>         <a class="code" href="classOgre_1_1CompositorManager.html#a0f0f6dee9b0bbd03f85b9bdaf768dd40" title="Map of registered compositor logics.">CompositorLogicMap</a> <a class="code" href="classOgre_1_1CompositorManager.html#ac4c61ca88567ecb84701e6b460fcb375">mCompositorLogics</a>;
<a name="l00213"></a>00213 
<a name="l00215"></a><a class="code" href="classOgre_1_1CompositorManager.html#a38f8d8ca331ce6e5abb215b8571525fc">00215</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, CustomCompositionPass*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#a38f8d8ca331ce6e5abb215b8571525fc" title="Map of registered custom composition passes.">CustomCompositionPassMap</a>;
<a name="l00216"></a><a class="code" href="classOgre_1_1CompositorManager.html#a88a908e54704f9a0ba1f4bf6fd60d9a0">00216</a>         <a class="code" href="classOgre_1_1CompositorManager.html#a38f8d8ca331ce6e5abb215b8571525fc" title="Map of registered custom composition passes.">CustomCompositionPassMap</a> <a class="code" href="classOgre_1_1CompositorManager.html#a88a908e54704f9a0ba1f4bf6fd60d9a0">mCustomCompositionPasses</a>;
<a name="l00217"></a>00217 
<a name="l00218"></a><a class="code" href="classOgre_1_1CompositorManager.html#a5b6ffdac9d101473a3335bb1218b0dcf">00218</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;TexturePtr&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#a5b6ffdac9d101473a3335bb1218b0dcf">TextureList</a>;
<a name="l00219"></a><a class="code" href="classOgre_1_1CompositorManager.html#a8950553cb67d78b6fa14681e400d726f">00219</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;TextureList&gt;</a> <a class="code" href="classOgre_1_1CompositorManager.html#a8950553cb67d78b6fa14681e400d726f">TextureIterator</a>;
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html">00221</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html">TextureDef</a>
<a name="l00222"></a>00222         {
<a name="l00223"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a3eaf7292bb08ab679ad8d87b18e405b4">00223</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a3eaf7292bb08ab679ad8d87b18e405b4">width</a>, height;
<a name="l00224"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ae0a7035f54b5dee24d07ffbdc21bc741">00224</a>             <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ae0a7035f54b5dee24d07ffbdc21bc741">format</a>;
<a name="l00225"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a29bbfa8ee69e812c8bb883d09d402557">00225</a>             <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a29bbfa8ee69e812c8bb883d09d402557">fsaa</a>;
<a name="l00226"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a007ab7ef6c8fa3822578b64d91b1ed71">00226</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a007ab7ef6c8fa3822578b64d91b1ed71">fsaaHint</a>;
<a name="l00227"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ab55e3d6e4b0e85210020ff5cdee2851b">00227</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ab55e3d6e4b0e85210020ff5cdee2851b">sRGBwrite</a>;
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a81aad978061ded4c38196d8f5c9ae061">00229</a>             <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html">TextureDef</a>(<span class="keywordtype">size_t</span> w, <span class="keywordtype">size_t</span> h, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> f, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> aa, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; aaHint, <span class="keywordtype">bool</span> srgb)
<a name="l00230"></a>00230                 : width(w), height(h), format(f), fsaa(aa), fsaaHint(aaHint), sRGBwrite(srgb)
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232 
<a name="l00233"></a>00233             }
<a name="l00234"></a>00234         };
<a name="l00235"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDefLess.html">00235</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDefLess.html">TextureDefLess</a>
<a name="l00236"></a>00236         {
<a name="l00237"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDefLess.html#a01feca4702cf2145bda37ebb22231547">00237</a>             <span class="keywordtype">bool</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html">TextureDef</a>&amp; x, <span class="keyword">const</span> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html">TextureDef</a>&amp; y)<span class="keyword"> const</span>
<a name="l00238"></a>00238 <span class="keyword">            </span>{
<a name="l00239"></a>00239                 <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ae0a7035f54b5dee24d07ffbdc21bc741">format</a> &lt; y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ae0a7035f54b5dee24d07ffbdc21bc741">format</a>)
<a name="l00240"></a>00240                     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00241"></a>00241                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ae0a7035f54b5dee24d07ffbdc21bc741">format</a> == y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ae0a7035f54b5dee24d07ffbdc21bc741">format</a>)
<a name="l00242"></a>00242                 {
<a name="l00243"></a>00243                     <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a3eaf7292bb08ab679ad8d87b18e405b4">width</a> &lt; y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a3eaf7292bb08ab679ad8d87b18e405b4">width</a>)
<a name="l00244"></a>00244                         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00245"></a>00245                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a3eaf7292bb08ab679ad8d87b18e405b4">width</a> == y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a3eaf7292bb08ab679ad8d87b18e405b4">width</a>)
<a name="l00246"></a>00246                     {
<a name="l00247"></a>00247                         <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#adbcf550852efc25f52afe62e60eba5bb">height</a> &lt; y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#adbcf550852efc25f52afe62e60eba5bb">height</a>)
<a name="l00248"></a>00248                             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00249"></a>00249                         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#adbcf550852efc25f52afe62e60eba5bb">height</a> == y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#adbcf550852efc25f52afe62e60eba5bb">height</a>)
<a name="l00250"></a>00250                         {
<a name="l00251"></a>00251                             <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a29bbfa8ee69e812c8bb883d09d402557">fsaa</a> &lt; y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a29bbfa8ee69e812c8bb883d09d402557">fsaa</a>)
<a name="l00252"></a>00252                                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00253"></a>00253                             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a29bbfa8ee69e812c8bb883d09d402557">fsaa</a> == y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a29bbfa8ee69e812c8bb883d09d402557">fsaa</a>)
<a name="l00254"></a>00254                             {
<a name="l00255"></a>00255                                 <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a007ab7ef6c8fa3822578b64d91b1ed71">fsaaHint</a> &lt; y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a007ab7ef6c8fa3822578b64d91b1ed71">fsaaHint</a>)
<a name="l00256"></a>00256                                     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00257"></a>00257                                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a007ab7ef6c8fa3822578b64d91b1ed71">fsaaHint</a> == y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#a007ab7ef6c8fa3822578b64d91b1ed71">fsaaHint</a>)
<a name="l00258"></a>00258                                 {
<a name="l00259"></a>00259                                     <span class="keywordflow">if</span> (!x.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ab55e3d6e4b0e85210020ff5cdee2851b">sRGBwrite</a> &amp;&amp; y.<a class="code" href="structOgre_1_1CompositorManager_1_1TextureDef.html#ab55e3d6e4b0e85210020ff5cdee2851b">sRGBwrite</a>)
<a name="l00260"></a>00260                                         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00261"></a>00261                                 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263                             }
<a name="l00264"></a>00264                         }
<a name="l00265"></a>00265                     }
<a name="l00266"></a>00266                 }
<a name="l00267"></a>00267                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00268"></a>00268             }
<a name="l00269"></a><a class="code" href="structOgre_1_1CompositorManager_1_1TextureDefLess.html#a8831ac3d4a210af740e29f2740e08538">00269</a>             <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1CompositorManager_1_1TextureDefLess.html#a8831ac3d4a210af740e29f2740e08538">~TextureDefLess</a>() {}
<a name="l00270"></a>00270         };
<a name="l00271"></a><a class="code" href="classOgre_1_1CompositorManager.html#a8bd86ca5733f701a3097ff42f75a3849">00271</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;TextureDef, TextureList*, TextureDefLess&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#a8bd86ca5733f701a3097ff42f75a3849">TexturesByDef</a>;
<a name="l00272"></a><a class="code" href="classOgre_1_1CompositorManager.html#a12956874693450cbe405aed7b2662110">00272</a>         <a class="code" href="classOgre_1_1CompositorManager.html#a8bd86ca5733f701a3097ff42f75a3849">TexturesByDef</a> <a class="code" href="classOgre_1_1CompositorManager.html#a12956874693450cbe405aed7b2662110">mTexturesByDef</a>;
<a name="l00273"></a>00273 
<a name="l00274"></a><a class="code" href="classOgre_1_1CompositorManager.html#a6df1c29c262910330b8238883de1c2c2">00274</a>         <span class="keyword">typedef</span> std::pair&lt;String, String&gt; <a class="code" href="classOgre_1_1CompositorManager.html#a6df1c29c262910330b8238883de1c2c2">StringPair</a>;
<a name="l00275"></a><a class="code" href="classOgre_1_1CompositorManager.html#aa3a4f1a74e12b4c8547770197ad99b7a">00275</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;TextureDef, TexturePtr, TextureDefLess&gt;::type</a> <a class="code" href="classOgre_1_1CompositorManager.html#aa3a4f1a74e12b4c8547770197ad99b7a">TextureDefMap</a>;
<a name="l00276"></a><a class="code" href="classOgre_1_1CompositorManager.html#a615e55131af242229a7ed215278dbc58">00276</a>         <span class="keyword">typedef</span> std::map&lt;StringPair, TextureDefMap&gt; <a class="code" href="classOgre_1_1CompositorManager.html#a615e55131af242229a7ed215278dbc58">ChainTexturesByDef</a>;
<a name="l00277"></a>00277         
<a name="l00278"></a><a class="code" href="classOgre_1_1CompositorManager.html#aaf81c8995f5cb4c09991d0c18622a4fe">00278</a>         <a class="code" href="classOgre_1_1CompositorManager.html#a615e55131af242229a7ed215278dbc58">ChainTexturesByDef</a> <a class="code" href="classOgre_1_1CompositorManager.html#aaf81c8995f5cb4c09991d0c18622a4fe">mChainTexturesByDef</a>;
<a name="l00279"></a>00279 
<a name="l00280"></a>00280         <span class="keywordtype">bool</span> isInputPreviousTarget(<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* inst, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; localName);
<a name="l00281"></a>00281         <span class="keywordtype">bool</span> isInputPreviousTarget(<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* inst, <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> tex);
<a name="l00282"></a>00282         <span class="keywordtype">bool</span> isInputToOutputTarget(<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* inst, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; localName);
<a name="l00283"></a>00283         <span class="keywordtype">bool</span> isInputToOutputTarget(<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* inst, <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> tex);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     };
<a name="l00289"></a>00289 }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
